//Titel:        JTree
//Version:       1.0
//Copyright:     Copyright (c) 2003 ,06
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einführung in JTree


// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNodeRec liefert Zusatzinformationen, mit toString
// Klick Ereignis, Single bzw. Double-Click

// Klickereignis mittels Event

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.tree.*;

import javax.swing.event.*;

import java.io.*;

import java.util.Vector;



public class Tree12 extends JFrame {

  JTree jTree1;
  DefaultMutableTreeNode rootNode;
  DefaultTreeModel treeModel;
  TreePath RootPath;

  int _index;

  // Interface-Methode
   public void CreateWindow( int i ) {
    System.out.println("CreateWindow: "+i);
   }

  public Tree12() {
    setGUI();
  }

  private void setGUI() {
    setSize(400, 300);
    setTitle("JTree 12. Beispiel");
    this.getContentPane().setLayout( new BorderLayout() );


    //---------------------------------------
    rootNode = BuildTree();

    treeModel = new DefaultTreeModel(rootNode);
    jTree1 = new javax.swing.JTree(treeModel);  //  kein Root !!!


    jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);


    jTree1.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseClicked(MouseEvent e) {
        jTree1_mouseClicked(e);
      }
    });

    // jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
   //  SINGLE_TREE_SELECTION, CONTIGUOUS_TREE_SELECTION or DISCONTIGUOUS_TREE_SELECTION.

                /*
     MouseListener ml = new CMouseAdapter(jTree1);
     jTree1.addMouseListener(ml);
                  */

    jTree1.setBorder(BorderFactory.createLineBorder(Color.black));
    jTree1.setToolTipText("ToolTipp");
    jTree1.setShowsRootHandles(true);

      // Horizontale Linien
    jTree1.putClientProperty("JTree.lineStyle","Horizontal");
      // Mit Linien zwischen den Knoten
    jTree1.putClientProperty("JTree.lineStyle","Angled");

    this.getContentPane().add(jTree1, BorderLayout.CENTER);

    // Neue Version
    // setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

  }  // setGUI


  void jTree1_mouseClicked(MouseEvent e) {
     if(e.getClickCount() == 2) {
        DefaultMutableTreeNode node;
        CTreeNodeRec CNode;
        node = (DefaultMutableTreeNode) jTree1.getLastSelectedPathComponent();
        if (node == null) {
           return;
        }
        else {
          CNode = (CTreeNodeRec) node.getUserObject();
          System.out.println("CDoubleClick: "+node.toString()+" \n" +CNode.getData() );
          if ( CNode.getData()>2 ) {
            // Aufruf und Erzeugen eines Dialogfensters
             CreateWindow( CNode.getData() );
             setTitle("Data größer 2");
          }
          else {
            setTitle("Tree11.java, getData <=2");
          }
        }
     }

  }

  // ----------------------------
  DefaultMutableTreeNode BuildTree() {
    DefaultMutableTreeNode root;
    DefaultMutableTreeNode[]  Knoten = new DefaultMutableTreeNode[3];

    root = createCNode(  0,"root");  // new DefaultMutableTreeNode("root");

      // liefert einen DefaultMutableTreeNode
    Knoten[0] = createCNode(  1,"1. Stufe (1)");
    root.add( Knoten[0] );

    Knoten[1] = createCNode(  2,"AAA");
    Knoten[0].add( Knoten[1] );  // Parameter Vater
    Knoten[1] = createCNode(  3,"BBB");
    Knoten[0].add( Knoten[1] );  // Parameter Vater


    // ---------

    Knoten[0] = createCNode(  2,"1. Stufe (2)");
    root.add( Knoten[0] );

    Knoten[1] = createCNode(  6,"CCC");
    Knoten[0].add( Knoten[1] );  // Parameter Vater
    Knoten[1] = createCNode(  2,"DDDD");
    Knoten[0].add( Knoten[1] );  // Parameter Vater


    Knoten[0] = createCNode(  3,"1. Stufe (3)");
    root.add( Knoten[0] );

    Knoten[1] = createCNode(  6,"EEE");
    Knoten[0].add( Knoten[1] );  // Parameter Vater

      Knoten[2] = createCNode(  7,"E1E1E1");
      Knoten[1].add( Knoten[2] );  // Parameter Vater
      Knoten[2] = createCNode(  2,"E2E2E2");
      Knoten[1].add( Knoten[2] );  // Parameter Vater

    Knoten[1] = createCNode(  11,"FFF");
    Knoten[0].add( Knoten[1] );  // Parameter Vater
      Knoten[2] = createCNode(  2,"F1F1F1");
      Knoten[1].add( Knoten[2] );  // Parameter Vater
      Knoten[2] = createCNode(  4,"F2F2F2");
      Knoten[1].add( Knoten[2] );  // Parameter Vater

    return root;
  }  // BuildTree


 DefaultMutableTreeNode createCNode(int CData,  String nodeString) {
    CTreeNodeRec CNode;
    DefaultMutableTreeNode Node;

    CNode = new  CTreeNodeRec(CData, nodeString);
    Node = new DefaultMutableTreeNode(CNode);
    // Node = new DefaultMutableTreeNode(nodeString);
    //Node.setUserObject(CNode);
    return Node;
 }



  //Überschreiben, damit das Programm bei Herunterfahren des Systems beendet werden kann
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  public static void main(String[] args) {
    Tree12 frame = new Tree12();
    frame.setVisible(true);
 }


}




// Einfache Klasse für jeden Knoten
class CTreeNodeRec  {
  public static long nr=0;

    private long _id = 0; // Id des Knotens  z.B. als ID

    private int _CData;

    public String _nodeString;


   public CTreeNodeRec(int CData,  String nodeString) {
      _CData = CData;
      _nodeString = nodeString;  // für JTree;
      nr++;
      _id = nr;  // setzt eindeutige Nummer
   }


   public long getID() {
     return _id;
   }

   public int getData() {
     return _CData;
   }

   public void setData(int CData) {
     _CData = CData;
   }


   // sehr wichtig
   public String toString() {
     return _nodeString;
   }
   

}  // CTreeNodeRec




